<?php
/*
  $Id$

  Purchase without Account for Phoenix
  Version 4.5.0 Phoenix
  by @raiwa
  info@oscaddons.com
  www.oscaddons.com
  all credits to @deDocta

  Copyright (c) 2021 Rainer Schmied

  CE Phoenix, E-Commerce made Easy
  https://phoenixcart.org

  Copyright (c) 2021 Phoenix Cart

  Released under the GNU General Public License
*/

  chdir('../../../../');
  require 'includes/application_top.php';

// if the customer is not logged on, carry on, must be a guest
	if ( !isset($_SESSION['customer_id']) )  {

    if ( !isset($_GET['pwa_id']) || !isset($_GET['products_id'])) {
      Href::redirect($Linker->build('product_info.php')->retain_parameters(['action']));
    }

    require language::map_to_translation('modules/content/reviews/write.php');

    $pwa_id = (isset($_GET['pwa_id']) ? Text::prepare($_GET['pwa_id']) : '');

    $product_info_query = $db->query(sprintf(<<<'EOSQL'
SELECT p.*, pd.*, SUBSTRING_INDEX(pd.products_description, ' ', 40) AS products_description
 FROM products p INNER JOIN products_description pd ON p.products_id = pd.products_id
 WHERE p.products_status = 1 AND p.products_id = %d AND pd.language_id = %d
EOSQL
    , (int)$_GET['products_id'], (int)$_SESSION['languages_id']));

    if (!mysqli_num_rows($product_info_query)) {
      Href::redirect($Linker->build('product_info.php')->retain_parameters(['action']));
    } else {
      $product_info = $product_info_query->fetch_assoc();
    }

  // check that pwa_id exits
    $customer_query = $db->query(sprintf(<<<'EOSQL'
SELECT customers_name, orders_id
  FROM orders
  WHERE reviews_key = '%s'
EOSQL
    , $db->escape($pwa_id)));

    if (!mysqli_num_rows($customer_query)) {
      Href::redirect($Linker->build('product_info.php')->retain_parameters(['action']));
    } else {
      $guest_customer = $customer_query->fetch_assoc();
    }

  // need to check that products_id relates to the pwa_id
    $orders_products_query = $db->query(sprintf(<<<'EOSQL'
SELECT products_id
  FROM orders_products
  WHERE orders_id = %s
EOSQL
    , (int)$guest_customer['orders_id']));

    $status = false;
    while($orders_products = $orders_products_query->fetch_assoc()) {
      if ((int)$_GET['products_id'] == $orders_products['products_id']) $status = true;
    }
    if ($status == false) {
      Href::redirect($Linker->build('product_info.php')->retain_parameters(['action']));
    }

    if (Form::validate_action_is('process')) {
      $rating = Text::input($_POST['rating']);
      $review = Text::prepare($_POST['review']);
      $nickname = Text::prepare($_POST['nickname']);

      if (ALLOW_ALL_REVIEWS == 'false') {
        if ($_POST['nickname'] !=$guest_customer['customers_name']) {
          $nickname = sprintf(VERIFIED_BUYER, $nickname);
        }
      }

      $db->query(sprintf(<<<'EOSQL'
INSERT INTO reviews (products_id, customers_id, customers_name, customers_guest, reviews_rating, date_added)
  VALUES (%s, 0, '%s', '1', '%s', now())
EOSQL
      , (int)$_GET['products_id'], $db->escape($nickname), $db->escape($rating)));

      $insert_id = mysqli_insert_id($db);

      $db->query(sprintf(<<<'EOSQL'
INSERT INTO reviews_description (reviews_id, languages_id, reviews_text)
  VALUES (%s, %s, '%s')
EOSQL
      , (int)$insert_id, (int)$languages_id, $db->escape($review)));

      $messageStack->add_session('product_action', sprintf(TEXT_REVIEW_RECEIVED, htmlspecialchars($customer['customers_name'])), 'success');

      Href::redirect($Linker->build('product_info.php')->retain_parameters(['action']));
    }

    if ($new_price = tep_get_products_special_price($product_info['products_id'])) {
      $products_price = '<del>' . $currencies->display_price($product_info['products_price'], tep_get_tax_rate($product_info['products_tax_class_id'])) . '</del> <span class="productPrice text-danger productSpecialPrice">' . $currencies->display_price($new_price, tep_get_tax_rate($product_info['products_tax_class_id'])) . '</span>';
    } else {
      $products_price = $currencies->display_price($product_info['products_price'], tep_get_tax_rate($product_info['products_tax_class_id']));
    }

  } else {
	  // customer logged on so not a guest
    Href::redirect($Linker->build('index.php'));
  }

  require $oscTemplate->map_to_template(__FILE__, 'ext');
  require 'includes/application_bottom.php';
