<?php
/*
  Purchase without Account for Phoenix
  Version 4.5.1 Phoenix
  by @raiwa
  info@oscaddons.com
  www.oscaddons.com
  all credits to @deDocta

  Copyright (c) 2021 Rainer Schmied

  CE Phoenix, E-Commerce made Easy
  https://phoenixcart.org

  Copyright (c) 2021 Phoenix Cart

  Released under the GNU General Public License
*/

class hook_admin_siteWide_swPwa {
  
  public $version = '4.5.1';

  function listen_statusUpdateEmail($data) {
    global $check_status, $notify_comments, $orders_status_array, $status, $comments;

    if (  $GLOBALS['PHP_SELF'] == 'orders.php' && isset($_POST['add_reviews']) && ($_POST['notify'] == 'on') ) {

      $this->load_lang();

      $order = new order($data['orders_id']);

      $products_review_links = HOOK_SWPWA_REVIEWS . ':' . "\n";
      for ($i=0, $n=sizeof($order->products); $i<$n; $i++) {
        if ($check_status['customers_guest'] == '1') {
          $products_review_links .= '<a href="' . Guarantor::ensure_global('Linker')->build('ext/modules/content/reviews/write_pwa.php', 'products_id=' . Product::build_prid($order->products[$i]['id']) . '&pwa_id=' . $check_status['reviews_key']) . '">' . $order->products[$i]['name'] . '</a>' . "\n";
        } elseif ($check_status['customers_guest'] != '1') {
          $products_review_links .= '<a href="' . Guarantor::ensure_global('Linker')->build('ext/modules/content/reviews/write.php', 'products_id=' . Product::build_prid($order->products[$i]['id'])) . '">' . $order->products[$i]['name'] . '</a>' . "\n";
        }
      }
    }
    $link = $check_status['customers_guest'] != '1' ? MODULE_NOTIFICATIONS_UPDATE_ORDER_TEXT_INVOICE_URL . ' ' . Guarantor::ensure_global('Linker')->build('account_history_info.php', 'order_id=' . $data['orders_id']) . "\n" : '';
    $email = STORE_NAME . "\n" . MODULE_NOTIFICATIONS_UPDATE_ORDER_SEPARATOR . "\n" .
             sprintf(MODULE_NOTIFICATIONS_UPDATE_ORDER_TEXT_ORDER_NUMBER .  "\n", $data['orders_id']) .
             $link .
             sprintf(MODULE_NOTIFICATIONS_UPDATE_ORDER_TEXT_DATE_ORDERED .  "\n", tep_date_long($data['date_purchased'])) . "\n\n" .
             $products_review_links . "\n" .
             $data['notify_comments'] .
             sprintf(MODULE_NOTIFICATIONS_UPDATE_ORDER_TEXT_STATUS_UPDATE, $data['status_name']);

    ob_get_clean();
    ob_start();

    return $email;

  }
    
  function listen_preAction() {
    global $db;

    $delete_action = ($_GET['action'] ?? '');

    if ( $GLOBALS['PHP_SELF'] == 'customers.php' && 'delete_guests' === $delete_action) {

      $this->load_lang();

      $delete_guests_query = $db->query(<<<'EOSQL'
SELECT GROUP_CONCAT(c.customers_id)
  FROM customers c, customers_info ci
  WHERE c.customers_guest = '1'
    AND c.customers_id = ci.customers_info_id
    AND ci.customers_info_date_account_created <= curdate() - interval 2 day
EOSQL
      );

      $delete_guests = $delete_guests_query->fetch_assoc();
      $guests_to_delete = $delete_guests['GROUP_CONCAT(c.customers_id)'];
      $num_guests = count(explode(',', $guests_to_delete));

      if ( $num_guests > 0 ) {

        $GLOBALS['messageStack']->add_session(sprintf(HOOK_SWPWA_TEXT_MESSAGE_SUCCESS, $num_guests), 'success');

        $db->query(sprintf(<<<'EOSQL'
DELETE
  FROM customers
  WHERE customers_id IN (%s)
    AND customers_guest = '1'
EOSQL
        , $guests_to_delete));

        $db->query(sprintf(<<<'EOSQL'
DELETE
  FROM address_book
  WHERE customers_id IN (%s)
EOSQL
        , $guests_to_delete));

        $db->query(sprintf(<<<'EOSQL'
DELETE
  FROM customers_info
  WHERE customers_info_id IN (%s)
EOSQL
        , $guests_to_delete));

        $db->query(sprintf(<<<'EOSQL'
DELETE
  FROM customers_basket
  WHERE customers_id IN (%s)
EOSQL
      , $guests_to_delete));

        $db->query(sprintf(<<<'EOSQL'
DELETE
  FROM customers_basket_attributes
  WHERE customers_id IN (%s)
EOSQL
        , $guests_to_delete));

        $maxlifetime = 259200; // 72 hours
        $db->query(sprintf(<<<'EOSQL'
DELETE
  FROM sessions
  WHERE value LIKE '%%customer_is_guest%%'
    AND expiry < '%s'
EOSQL
        , (time() - $maxlifetime)));

        Href::redirect(Guarantor::ensure_global('Admin')->link('customers.php'));
      }
    }
  }

  function listen_injectSiteEnd() {
    global $PHP_SELF, $action, $orders_query_numrows;

    $output = null;

    if ($PHP_SELF == 'orders.php') {

      $this->load_lang();

      if ( !isset($action) || $action != 'edit' ) {
        global $orders_query;
        $orders = $orders_query->data_seek(0);

        $header_title_guest = HOOK_SWPWA_GUEST;

        $output = <<<EOD
<script>
$(function() {
$('table thead tr th:nth-child(4)').after('<th class="text-center">{$header_title_guest}</th>');
EOD;

        while ($orders = $orders_query->fetch_assoc()) {
          $orders_id = $orders['orders_id'];
          $customer_guest = $orders['customers_guest'] == '1' ? '<i class="fas fa-check"></i>' : '';

          $output .=  PHP_EOL . <<<EOD
$('table tbody tr:has([href$="oID={$orders_id}&action=edit"]) td:eq(4)').before('<td class="text-center">{$customer_guest}</td>');
EOD;

      }

        $output .= <<<EOD
});
</script>
EOD;

      } elseif($action == 'edit') {

        $guest_review = '<div class="form-group row align-items-center">';
        $guest_review .= '<div class="col-form-label col-sm-3 text-left text-sm-right">' . HOOK_SWPWA_REVIEWS_STATUS . '</div>';
        $guest_review .= '<div class="col-sm-9 pl-5 custom-control custom-switch">';
        $guest_review .= tep_draw_selection_field('add_reviews', 'checkbox', 'on', 1, 'class="custom-control-input" id="oAddReviews"');
        $guest_review .= '<label for="oAddReviews" class="custom-control-label text-muted"><small>' . HOOK_SWPWA_REVIEWS_STATUS_TEXT . '</small></label>';
        $guest_review .= '</div>';
        $guest_review .= '</div>';

        $output = <<<EOD
<script>
$(function() {
$('#oNotifyComments').closest('div').parent().closest('div').after('{$guest_review}');
});
</script>
EOD;

      }
    } elseif ($PHP_SELF == 'customers.php' ) {
      global $search, $customer_data, $db;

      $this->load_lang();

      $header_title_guest = HOOK_SWPWA_GUEST;

      $output = <<<EOD
<script>
$(function() {
$('table thead tr th:nth-child(2)').after('<th class="text-center">{$header_title_guest}</th>');
EOD;

      $customers_query_raw = $customer_data->build_read([ 'id', 'sortable_name', 'email_address', 'country_id', 'customers_guest'], 'customers');
      $keywords = null;
      if (!empty($_GET['search'])) {
        $keywords = Text::prepare($_GET['search']);
        $customers_query_raw = $customer_data->add_search_criteria($customers_query_raw, $keywords);
      }
      $customers_query_raw = $customer_data->add_order_by($customers_query_raw, ['sortable_name']);

      $customers_split = new splitPageResults($_GET['page'], MAX_DISPLAY_SEARCH_RESULTS, $customers_query_raw, $customers_query_numrows);
      $customers_query = $db->query($customers_query_raw);
      $i = 0;
      while ($customers = $customers_query->fetch_assoc()) {
        $i++;
        $customers_id = $customers['customers_id'];
        $customer_guest = $customers['customers_guest'] == '1' ? '<i class="fas fa-check"></i>' : '';
        if ( (!isset($_GET['cID']) && $i == 1) || (isset($_GET['cID']) && $_GET['cID'] == $customers_id) ) {
          $output .=  PHP_EOL . <<<EOD
$('table tbody .table-active td:eq(2)').before('<td class="text-center">{$customer_guest}</td>');
EOD;
        } else {
          $output .=  PHP_EOL . <<<EOD
$('table tbody tr:has([href$="cID={$customers_id}"]) td:eq(2)').before('<td class="text-center">{$customer_guest}</td>');
EOD;
        }
      }

      $guests_query = $db->query(<<<'EOSQL'
SELECT COUNT(*) AS total
  FROM customers c, customers_info ci
  WHERE c.customers_guest = '1'
    AND c.customers_id = ci.customers_info_id
    AND ci.customers_info_date_account_created <= curdate() - interval 2 day
EOSQL
      );

      $guests = $guests_query->fetch_assoc();

      if ( $guests['total'] > 0 ) {
        $delete_guest_button = new Button(HOOK_SWPWA_BUTTON_DELETE_GUESTS, 'fas fa-trash', 'btn-danger', [], Guarantor::ensure_global('Admin')->link('customers.php', 'action=delete_guests')) . '<br>' . sprintf(HOOK_SWPWA_TEXT_DELETE_GUESTS, $guests['total']);

        $output .=  PHP_EOL . <<<EOD
$('table:eq(1) tbody tr:nth-last-child(1)').after('<tr><td>{$delete_guest_button}</td></tr>');
EOD;
      }

      $output .= <<<EOD
});
</script>
EOD;

    } elseif ($PHP_SELF == 'reviews.php' ) {
      global $reviews_query;

      if ( empty($action) || $action == 'delete' ) {
        $this->load_lang();

        $reviews = $reviews_query->data_seek(0);

        $header_title_guest = HOOK_SWPWA_GUEST;

        $output = <<<EOD
<script>
$(function() {
$('table thead tr th:nth-child(3)').after('<th class="text-center">{$header_title_guest}</th>');
EOD;

        while ($reviews = $reviews_query->fetch_assoc()) {
          $reviews_status = ($reviews['reviews_status'] == '1')? '0' : '1';
          $reviews_id = $reviews['reviews_id'];
          $customer_guest = $reviews['customers_guest'] == '1' ? '<i class="fas fa-check"></i>' : '&nbsp;';

          $output .=  PHP_EOL . <<<EOD
        $('table tbody tr td:has([href*="action=setflag&flag={$reviews_status}&rID={$reviews_id}"])').before('<td class="text-center">{$customer_guest}</td>');
EOD;
      }

        $output .= <<<EOD
});
</script>
EOD;

      }
    }

    return $output;

  }

  function listen_accountEditPages($parameters) {
    $parameters['pages'][] = 'create_account_pwa';
  }

  function load_lang() {

    require language::map_to_translation('hooks/admin/siteWide/swPwa.php');
  }

}
