<?php
/*
  $Id$

  Purchase without Account for Phoenix
  Version 4.5.0 Phoenix
  by @raiwa
  info@oscaddons.com
  www.oscaddons.com
  all credits to @deDocta

  Copyright (c) 2021 Rainer Schmied

  CE Phoenix, E-Commerce made Easy
  https://phoenixcart.org

  Copyright (c) 2021 Phoenix Cart

  Released under the GNU General Public License
*/

  class cm_pwa_login extends abstract_executable_module {

    const CONFIG_KEY_BASE = 'MODULE_CONTENT_PWA_LOGIN_';

    public function __construct() {
      parent::__construct(__FILE__);

      global $cart;

      if (is_object($cart)) {
        $cart_content = $cart->get_content_type();
        $cart_count = $cart->count_contents();
        if ( $cart_count < 1 || (MODULE_CONTENT_PWA_LOGIN_VIRTUAL != 'True' && $cart_content != 'physical') ) {
          $this->enabled = false;
        }
      }

      if (!file_exists(DIR_FS_CATALOG . 'templates/' . TEMPLATE_SELECTION . '/includes/hooks/shop/siteWide/pwa.php')) {
        $this->description = '<div class="alert alert-danger" role="alert">' .
                                 MODULE_CONTENT_PWA_LOGIN_HOOK_MODULE_WARNING .
                             '</div>' .
                             $this->description;
        $this->enabled = false;
      }

    }

    public function execute() {

      $content_width = (int)MODULE_CONTENT_PWA_LOGIN_CONTENT_WIDTH;

        $tpl_data = [ 'group' => $this->group, 'file' => __FILE__ ];
        include 'includes/modules/content/cm_template.php';
    }

    protected function get_parameters() {
      return [
        'MODULE_CONTENT_PWA_LOGIN_VERSION' => [
          'title' => 'Current Version',
          'value' => '4.5.0. Phoenix',
          'desc' => 'Version info. It is read only',
          'set_func' => 'cm_pwa_login::readonly(',
        ],
        'MODULE_CONTENT_PWA_LOGIN_STATUS' => [
          'title' => 'Enable PWA Login Module',
          'value' => 'True',
          'desc' => 'Do you want to enable this module?',
          'set_func' => "tep_cfg_SELECT_option(['True', 'False'], ",
        ],
        'MODULE_CONTENT_PWA_LOGIN_CONTENT_WIDTH' => [
          'title' => 'Content Width',
          'value' => '6',
          'desc' => 'What width container should the content be shown in? (12 = full width, 6 = half width).',
          'set_func' => "tep_cfg_SELECT_option(['12', '11', '10', '9', '8', '7', '6', '5', '4', '3', '2', '1'], ",
        ],
        'MODULE_CONTENT_PWA_LOGIN_SORT_ORDER' => [
          'title' => 'Sort Order',
          'value' => '1500',
          'desc' => 'Sort order of display. Lowest is displayed first.',
        ],
        'MODULE_CONTENT_PWA_LOGIN_REMOVE_DATA' => [
          'title' => 'Uninstall Removes Database columns',
          'value' => 'False',
          'desc' => 'Do you want to remove the pwa guest flag column when uninstall the module? (Guest orders will not be deleted, but will loose their guest order flags)',
          'set_func' => "tep_cfg_SELECT_option(['True', 'False'], ",
        ],
        'MODULE_CONTENT_PWA_LOGIN_VIRTUAL' => [
          'title' => 'Allow guest checkout for virtual products',
          'value' => 'False',
          'desc' => 'Do you wish to allow guest checkout for orders containing virtual-downloadable products.<br>Also applies for mixed orders.',
          'set_func' => "tep_cfg_SELECT_option(['True', 'False'], ",
        ],
        'MODULE_CONTENT_PWA_LOGIN_PAYMENT_MODULES' => [
          'title' => 'Exclude Payment Modules for Virtual Guest Orders',
          'value' => '',
          'desc' => 'The payment modules to exclude for guests and orders including virtual (downloadable) products.<br>Needs payment class to be modified, see Instructions Step 2.4.<br>Adding a new payment module, requires un-reinstall this module to update this list.',
          'use_func' => 'cm_pwa_login::cm_pwa_login_show_payment_modules',
          'set_func' => 'cm_pwa_login::cm_pwa_login_edit_payment_modules(',
        ],
        'MODULE_CONTENT_PWA_LOGIN_CHECKOUT_GUEST_REVIEW_LINKS' => [
          'title' => 'Add Review Links to Guest Order Mail',
          'value' => 'True',
          'desc' => 'Do you wish to add a list with all products linked to the write review pages to the order confirmation Mail for guests?',
          'set_func' => "tep_cfg_SELECT_option(['True', 'False'], ",
        ],
        'MODULE_CONTENT_PWA_LOGIN_CHECKOUT_REGISTERED_REVIEW_LINKS' => [
          'title' => 'Add Review Links to Standard Order Mail',
          'value' => 'True',
          'desc' => 'Do you wish to add a list with all products linked to the write review pages to the order confirmation Mail for registered customers?',
          'set_func' => "tep_cfg_SELECT_option(['True', 'False'], ",
        ],
        'MODULE_CONTENT_PWA_LOGIN_REDIRECT_TO_PWA_ACCOUNT' => [
          'title' => 'Redirect to Create Account PWA',
          'value' => 'False',
          'desc' => 'Do you wish to redirect the login page to Create Account PWA? Use this if you wish to offer Guest Checkout as stand alone Option.',
          'set_func' => "tep_cfg_SELECT_option(['True', 'False'], ",
        ],
      ];
    }


    function install($parameter_key = null) {
      parent::install($parameter_key);
      global $db;

      if (mysqli_num_rows($db->query("SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='". DB_DATABASE . "' AND TABLE_NAME='orders' AND COLUMN_NAME LIKE 'customers_guest'")) != 1 ) {
        $db->query("ALTER TABLE orders ADD customers_guest INT(1) NOT NULL DEFAULT '0'");
      }
      if (mysqli_num_rows($db->query("SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='". DB_DATABASE . "' AND TABLE_NAME='orders' AND COLUMN_NAME LIKE 'reviews_key'")) != 1 ) {
        $db->query("ALTER TABLE orders ADD reviews_key VARCHAR(12) NOT NULL DEFAULT '0'");
      }
      if (mysqli_num_rows($db->query("SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='". DB_DATABASE . "' AND TABLE_NAME='customers' AND COLUMN_NAME LIKE 'customers_guest'")) != 1 ) {
        $db->query("ALTER TABLE customers ADD customers_guest INT(1) NOT NULL DEFAULT '0'");
      }
      if (mysqli_num_rows($db->query("SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='". DB_DATABASE . "' AND TABLE_NAME='reviews' AND COLUMN_NAME LIKE 'customers_guest'")) != 1 ) {
        $db->query("ALTER TABLE reviews ADD customers_guest INT(1) NOT NULL DEFAULT '0'");
      }
    }

    function remove($parameter_key = null) {
      parent::remove($parameter_key);
      global $db;

      if ( defined('MODULE_CONTENT_PWA_LOGIN_REMOVE_DATA') && MODULE_CONTENT_PWA_LOGIN_REMOVE_DATA == 'True' ) {
        $db->query("ALTER TABLE customers DROP customers_guest");
        $db->query("ALTER TABLE orders DROP customers_guest");
        $db->query("ALTER TABLE orders DROP reviews_key");
        $db->query("ALTER TABLE reviews DROP customers_guest");
      }
    }

    public static function readonly($value) {
      return $value;
    }

  public static function cm_pwa_login_show_payment_modules($text) {
    return nl2br(implode("\n", explode(';', $text)));
  }

  public static function cm_pwa_login_edit_payment_modules($values, $key) {
    global $PHP_SELF;

    $file_extension = substr($PHP_SELF, strrpos($PHP_SELF, '.'));
    $files_array = array();
	  if ($dir = @dir(DIR_FS_CATALOG . 'includes/modules/payment/')) {
	    while ($file = $dir->read()) {
	      if (!is_dir(DIR_FS_CATALOG . 'includes/modules/payment/' . $file)) {
	        if (substr($file, strrpos($file, '.')) == $file_extension) {
            $files_array[] = $file;
          }
        }
      }
      sort($files_array);
      $dir->close();
    }

    $values_array = explode(';', $values);
    $installed_values = explode(';', MODULE_PAYMENT_INSTALLED);

    $output = '';
    foreach ($files_array as $file) {
    	if ( in_array($file, $installed_values ) ) {
    		$output .= tep_draw_checkbox_field('cm_pwa_payment_module[]', $file, in_array($file, $values_array), null, True) . '&nbsp;' . tep_output_string($file) . '<br />';
    	}
    }

    if (!empty($output)) {
      $output = '<br>' . substr($output, 0, -6);
    }

    $output .= tep_draw_hidden_field('configuration[' . $key . ']', '', 'id="htrn_cm_pwa_payment_modules"');

    $output .= '<script>
                function htrn_cm_pwa_payment_update_cfg_value() {
                  var htrn_cm_pwa_payment_SELECTed_modules = \'\';

                  if ($(\'input[name="cm_pwa_payment_module[]"]\').length > 0) {
                    $(\'input[name="cm_pwa_payment_module[]"]:checked\').each(function() {
                      htrn_cm_pwa_payment_SELECTed_modules += $(this).attr(\'value\') + \';\';
                    });

                    if (htrn_cm_pwa_payment_SELECTed_modules.length > 0) {
                      htrn_cm_pwa_payment_SELECTed_modules = htrn_cm_pwa_payment_SELECTed_modules.substring(0, htrn_cm_pwa_payment_SELECTed_modules.length - 1);
                    }
                  }

                  $(\'#htrn_cm_pwa_payment_modules\').val(htrn_cm_pwa_payment_SELECTed_modules);
                }

                $(function() {
                  htrn_cm_pwa_payment_update_cfg_value();

                  if ($(\'input[name="cm_pwa_payment_module[]"]\').length > 0) {
                    $(\'input[name="cm_pwa_payment_module[]"]\').change(function() {
                      htrn_cm_pwa_payment_update_cfg_value();
                    });
                  }
                });
                </script>';

    return $output;
  }

}
