<?php
/*
  $Id: pwa.php
  $Loc: catalog/includes/hooks/shop/siteWide/

  Purchase without Account for Phoenix
  Version 4.5.0 Phoenix
  by @raiwa
  info@oscaddons.com
  www.oscaddons.com
  all credits to @deDocta

  Copyright (c) 2021 Rainer Schmied

  CE Phoenix, E-Commerce made Easy
  https://phoenixcart.org

  Copyright (c) 2021 Phoenix Cart

  Released under the GNU General Public License
*/

class hook_shop_siteWide_pwa {
  public $version = '4.5.0';

  function listen_orderMail($parameters) {

    $this->load_lang();

    $products_review_links = HOOK_PWA_EMAIL_REVIEWS . "\n";
    $email_order = &$parameters['email'];
    $order = $parameters['order'];

    if (isset($_SESSION['customer_is_guest'])) {
      $email_order = str_replace(MODULE_NOTIFICATIONS_CHECKOUT_TEXT_INVOICE_URL . ' ' . Guarantor::ensure_global('Linker')->build('checkout_shipping.php', 'order_id=' . $order->get_id()) . "\n", '', $email_order);
      $email_order .= HOOK_PWA_EMAIL_WARNING . "\n\n" .
                      MODULE_NOTIFICATIONS_CHECKOUT_SEPARATOR . "\n";
      if($order->content_type != 'physical') {
        $email_order .= sprintf(HOOK_PWA_EMAIL_DOWNLOAD, Guarantor::ensure_global('Linker')->build('contact_us.php')) . "\n" .
                        MODULE_NOTIFICATIONS_CHECKOUT_SEPARATOR . "\n";
      }
      $reviews_key = tep_create_random_value(12);
      $GLOBALS['db']->query(sprintf(<<<'EOSQL'
UPDATE orders
  SET reviews_key = '%s'
  WHERE customers_id = %s
    AND orders_id = %s
EOSQL
      , $reviews_key, (int)$_SESSION['customer_id'], (int)$order->get_id()));

      if (MODULE_CONTENT_PWA_LOGIN_CHECKOUT_GUEST_REVIEW_LINKS == 'True') {
        for ($i=0, $n=sizeof($order->products); $i<$n; $i++) {
          $products_review_links .= '<a href="' . Guarantor::ensure_global('Linker')->build('ext/modules/content/reviews/write_pwa.php', 'products_id=' . Product::build_prid($order->products[$i]['id']) . '&pwa_id=' . $check_status['reviews_key']) . '">' . $order->products[$i]['name'] . '</a>' . "\n";
        }
        $email_order .= $products_review_links . "\n" .
                        MODULE_NOTIFICATIONS_CHECKOUT_SEPARATOR . "\n";
      }
    } elseif (MODULE_CONTENT_PWA_LOGIN_CHECKOUT_REGISTERED_REVIEW_LINKS == 'True') {
      for ($i=0, $n=sizeof($order->products); $i<$n; $i++) {
        $products_review_links .= '<a href="' . Guarantor::ensure_global('Linker')->build('ext/modules/content/reviews/write.php', 'products_id=' . Product::build_prid($order->products[$i]['id'])) . '">' . $order->products[$i]['name'] . '</a>' . "\n";
      }
      $email_order .= $products_review_links . "\n" .
                      MODULE_NOTIFICATIONS_CHECKOUT_SEPARATOR . "\n";
      }

  }

  function listen_insertOrder($parameters) {
    $orders = &$parameters['sql_data']['orders'];
    $orders['customers_guest'] = (int)($_SESSION['customer_is_guest'] ?? 0);
  }

  function listen_injectAppTop() {
    global $PHP_SELF, $db;

    // redirect login to create account pwa if set
    if ( $GLOBALS['PHP_SELF'] == 'login.php' && defined('MODULE_CONTENT_PWA_LOGIN_REDIRECT_TO_PWA_ACCOUNT') && MODULE_CONTENT_PWA_LOGIN_REDIRECT_TO_PWA_ACCOUNT == 'True' ) {
      Href::redirect(Guarantor::ensure_global('Linker')->build('create_account_pwa.php'));
    }

    // check if guest account (e-mail) exists and remove if a new guest account is created
    if ( ($PHP_SELF == 'create_account.php' || $PHP_SELF == 'create_account_pwa.php') && isset($_POST['action']) && ($_POST['action'] == 'process') && isset($_POST['formid']) && ($_POST['formid'] == $_SESSION['sessiontoken'] ) )  {
      if (mysqli_num_rows($db->query("SELECT * FROM information_schema.columns WHERE table_schema='". DB_DATABASE . "' AND table_name='orders' AND column_name LIKE 'customers_guest'")) == 1 ) {
        $email_address = Text::prepare($_POST['email_address']);
        $check_guest_query = $db->query(sprintf(<<<'EOSQL'
SELECT customers_id
  FROM customers
  WHERE customers_email_address = '%s'
    AND customers_guest = '1'
EOSQL
        , $db->escape($email_address)));

        if ( mysqli_num_rows($check_guest_query) > 0 ) {
          $check_guest = $check_guest_query->fetch_assoc();
          $this->delete_guest_account($check_guest['customers_id']);

        }
      }
    }

// session unregister and delete account for guests on logoff
    if ( $GLOBALS['PHP_SELF'] == 'logoff.php' && isset($_SESSION['customer_is_guest']) ) {
      $this->delete_guest_account($_SESSION['customer_id']);
    }

// session unregister and delete account for guests
    if ( $PHP_SELF == 'checkout_success.php' && isset($_SESSION['customer_is_guest']) ) {
      $this->load_lang();

      $_SESSION['navigation']->set_snapshot();

      if ( isset($_GET['action']) && ($_GET['action'] == 'update') ) {
        // redirect to set password if selected
        if ( isset($_POST['pwa_account']) && $_POST['pwa_account'] == 'true' ) {
          if ( isset($_POST['notify']) && is_array($_POST['notify']) && !empty($_POST['notify']) ) {
            $notify = array_unique($_POST['notify']);

            foreach ( $notify as $n ) {
              if ( is_numeric($n) && ($n > 0) ) {
                $check_query = $db->query(sprintf(<<<'EOSQL'
SELECT products_id
  FROM products_notifications
    WHERE products_id = '%s'
      AND customers_id = %s
    LIMIT 1
EOSQL
                , (int)$n, (int)$_SESSION['customer_id']));

                if ( !mysqli_num_rows($check_query) ) {
                  $db->query(sprintf(<<<'EOSQL'
INSERT INTO products_notifications (products_id, customers_id, date_added)
  VALUES ('%s', %s, NOW())
EOSQL
                , (int)$n, (int)$_SESSION['customer_id']));

                }
              }
            }
          }
          Href::redirect(Guarantor::ensure_global('Linker')->build('ext/modules/content/account/set_password.php'));
        } elseif (!isset($_POST['pwa_account']) || ($_POST['pwa_account'] != 'true') ) {
          // delete guest account if selected
          $this->delete_guest_account($_SESSION['customer_id']);
        }
        if ( (!defined('MODULE_CONTENT_CHECKOUT_SUCCESS_PWA_KEEP_ACCOUNT_STATUS') || MODULE_CONTENT_CHECKOUT_SUCCESS_PWA_KEEP_ACCOUNT_STATUS != 'True') && DOWNLOAD_ENABLED != 'true' ) {
        // delete guest account
        $this->delete_guest_account($_SESSION['customer_id']);
        }
      }

      $guest_account_script = '
<script>
$(document).ready(function() {
$("input:checkbox[name^=\'notify\']").hide().attr("disabled", true);
$(".cm-cs-product-notifications .card-header").html(\'' . HOOK_PWA_TEXT_PRODUCTS . '\');
$(".cm-cs-thank-you .border .list-group-item-action:nth-of-type(1)").addClass(\'d-none\');' . "\n";

      if ( defined('MODULE_CONTENT_CHECKOUT_SUCCESS_PWA_KEEP_ACCOUNT_STATUS') && MODULE_CONTENT_CHECKOUT_SUCCESS_PWA_KEEP_ACCOUNT_STATUS == 'True' ) {
      $guest_account_script .= '
$("#download-account").html(\'<p>' . HOOK_PWA_DOWNLOAD . '</p>\');' . "\n";
      } else {
      $guest_account_script .= '
$("#download-account").text(\'\');' . "\n";
      }
      $guest_account_script .= '
$("input:radio[name=\'pwa_account\']").click(function() {
  if($("input:radio[name=\'pwa_account\'][value=\'false\']").is(\':checked\')) {
    console.log(\'selected\');
    $("input:checkbox[name^=\'notify\']").hide().attr("disabled", true);
    $(".cm-cs-product-notifications .card-header").html(\'' . HOOK_PWA_TEXT_PRODUCTS . '\');
    } else {
    console.log(\'notselected\');
    $("input:checkbox[name^=\'notify\']").show().removeAttr("disabled", true);
    $(".cm-cs-product-notifications .card-header").html(\'' . MODULE_CONTENT_CHECKOUT_SUCCESS_PRODUCT_NOTIFICATIONS_TEXT_NOTIFY_PRODUCTS . '\');
  }
});
});
</script>
      ' . "\n";

      $GLOBALS['oscTemplate']->addBlock($guest_account_script, 'footer_scripts');
    }

    if ( isset($_SESSION['customer_is_guest']) ) {
      if ( defined('MODULE_NAVBAR_ACCOUNT_STATUS') && MODULE_NAVBAR_ACCOUNT_STATUS == 'True' ) {
        $GLOBALS['oscTemplate']->addBlock('<script>$(".nb-account .dropdown-toggle").addClass("disabled");</script>', 'footer_scripts');
      }
      if ( defined('MODULE_CONTENT_HEADER_BUTTONS_STATUS') && MODULE_CONTENT_HEADER_BUTTONS_STATUS == 'True' ) {
        $GLOBALS['oscTemplate']->addBlock('<script>$(".cm-header-buttons .btn:nth-of-type(n+3)").addClass("disabled");</script>', 'footer_scripts');
      }
      if ( defined('MODULE_CONTENT_FOOTER_ACCOUNT_STATUS') && MODULE_CONTENT_FOOTER_ACCOUNT_STATUS == 'True' ) {
        $GLOBALS['oscTemplate']->addBlock('<script>$(".cm-footer-account .nav-link").addClass("disabled");</script>', 'footer_scripts');
      }
    }

    // do things if a guest comes from checkout success
    if ( isset($_SESSION['customer_is_guest']) && isset($_SESSION['navigation']->snapshot['page']) && $_SESSION['navigation']->snapshot['page'] == 'checkout_success.php' ) {
      if ( defined('MODULE_CONTENT_CHECKOUT_SUCCESS_PWA_KEEP_ACCOUNT_STATUS') && MODULE_CONTENT_CHECKOUT_SUCCESS_PWA_KEEP_ACCOUNT_STATUS == 'True' &&
        $PHP_SELF == 'account.php' && strpos($GLOBALS['messageStack']->output('account'), 'alert-success') ) {
        // Unregister and remove guest from customers table if password is successful set
        unset($_SESSION['customer_is_guest']);
        $db->query(sprintf(<<<'EOSQL'
UPDATE customers
  SET customers_guest = '0'
  WHERE customers_id = %s
EOSQL
              , (int)$_SESSION['customer_id']));

      } elseif ( $PHP_SELF != 'download.php' && basename($PHP_SELF) != 'set_password.php' && substr($PHP_SELF, 0, 8) != 'checkout' ) {
        // else delete guest account
        $this->delete_guest_account($_SESSION['customer_id']);
      }
    }

  }

  protected function delete_guest_account($customer_id) {
    global $db;
    
    $db->query(sprintf(<<<'EOSQL'
DELETE
  FROM customers
  WHERE customers_id = %s
    AND customers_guest = '1'
EOSQL
    , (int)$customer_id));

    $db->query(sprintf(<<<'EOSQL'
DELETE
  FROM address_book
  WHERE customers_id = %s
EOSQL
    , (int)$customer_id));

    $db->query(sprintf(<<<'EOSQL'
DELETE
  FROM customers_info
  WHERE customers_info_id = %s
EOSQL
    , (int)$customer_id));

    $db->query(sprintf(<<<'EOSQL'
DELETE
  FROM customers_basket
  WHERE customers_id = %s
EOSQL
    , (int)$customer_id));

    $db->query(sprintf(<<<'EOSQL'
DELETE
  FROM customers_basket_attributes
  WHERE customers_id = %s
EOSQL
    , (int)$customer_id));

    unset($_SESSION['customer_id']);
    unset($_SESSION['customer_default_address_id']);
    unset($_SESSION['customer_first_name']);
    unset($_SESSION['customer_country_id']);
    unset($_SESSION['customer_zone_id']);
    unset($_SESSION['customer_is_guest']);
  }

  function load_lang() {
    require language::map_to_translation('hooks/shop/siteWide/pwa.php');
  }

}
